﻿#NoEnv
#SingleInstance, Force
SetWorkingDir, %A_ScriptDir%  ; has no effect on #Include
SetBatchLines, -1
SendMode, Input
ListLines, Off
AutoTrim, Off
ptr := A_PtrSize ? "Ptr" : "UInt"  ; for compatibility with older AHK-Versions
If !A_IsAdmin
  {
  DllFunc := A_IsUnicode ? "shell32\ShellExecute" : "shell32\ShellExecuteA"
  DllCall(DllFunc, Ptr, 0, Str, "RunAs", Str, A_AhkPath, Str, """" . A_ScriptFullPath . """", Str, A_WorkingDir, int, 1)
  ExitApp
  }
IfEqual, A_IsUnicode, 1, FileEncoding, UTF-8  ; AHK_L
SplitPath, A_ScriptFullPath,,,, ScriptNoExt
ScriptTitle = OPHTHALMOSTAR-%ScriptNoExt%
FileContent := ""
SearchString := ""
StringLine := "`n"
ChangeFlag := False
MatchFlag := 0
HotkeyMenuAdd = &Hotstring hinzufügen
HotkeyMenuManage = &Liste anzeigen
Menu, Tray, NoStandard
Menu, Tray, DeleteAll
Menu, Tray, Add, &Hilfe, ButtonHilfe
Menu, Tray, Add
Menu, Tray, Add, &Optionen, Optionen
Menu, AutoHotkey, Standard
Menu, Tray, Add, AutoHotkey, :AutoHotkey
Menu, Tray, Add
Menu, Tray, Add, %HotkeyMenuAdd%, TextAufnehmen
Menu, Tray, Add, %HotkeyMenuManage%, ListeZeigen
Menu, Tray, Add
Menu, Tray, Add, &Beenden, ScriptEnde
Menu, Tray, Tip, %ScriptTitle%
Menu, Tray, Icon,,, 1
Menu, Tray, Default, &Liste anzeigen
Menu, Tray, Click, 1
IfNotExist, Hotstrings.ini
  {
    FileAppend,
      (
[Hotkeys]
EingabeKey=^#
      ), Hotstrings.ini
  }
IniRead, _HOTKEY, Hotstrings.ini, Hotkeys, EingabeKey, ^#
If (_HOTKEY = ERROR or _HOTKEY = "")
    _HOTKEY = ^#
Hotkey, %_HOTKEY%, TextAufnehmen
GoSub, HotkeyAendern
IniRead, V_Asterisk,  Hotstrings.ini, Vorgaben, DirektErsetzen, 1
IniRead, V_QuestMark, Hotstrings.ini, Vorgaben, ErsetzAuchIn, 0
IniRead, V_BFollZero, Hotstrings.ini, Vorgaben, NoBackspacing, 0
IniRead, V_OmitEnd,   Hotstrings.ini, Vorgaben, ZeichenIgnor, 0
IniRead, V_RawSend,   Hotstrings.ini, Vorgaben, KlarSenden, 0
IniRead, V_RecoReset, Hotstrings.ini, Vorgaben, ErkennMechan, 0
IniRead, V_CaseType, Hotstrings.ini, Vorgaben, GrossKlein, %A_Space%
IfNotExist, %ScriptNoExt%.txt
  {
    FileAppend, :*:mfg#::Mit freundlichen Grüßen, %ScriptNoExt%.txt
    If ErrorLevel = 0
      {
        MsgBox, 64, %ScriptTitle%, «Hotstrings.txt» nicht gefunden. Die Datei wird mit einem Beispieleintrag erstellt.`n`nKlicken Sie auf das Symbol im Infobereich der Taskleiste, um den Eintrag zu sehen.`n`nBitte passen Sie %ScriptTitle% Ihren individuellen Bedürfnissen an.`nMit einem Rechtsklick auf das Tray-Symbol gelangen Sie zum Optionen-Menü.
        Reload
        Sleep, 2000
      }
  }
Asterisk_TT := V_Asterisk_TT := "Interpunktionszeichen`, Leer-`, Enter- und Tab-Taste sind als Endzeichen bzw. Auslöser nicht erforderlich."
Question_TT := V_QuestMark_TT := "Wenn Sie diese Option aktivieren`, können Sie keine Kürzel verwenden`, die Bestandteil eines längeren Kürzels sind."
No_Backspacing_TT := V_BFollZero_TT := "Das getippte Kürzel wird nicht gelöscht.`nDie Ersetzung wird angehängt."
Omit_TT := V_OmitEnd_TT := "Das Endzeichen bzw. die Auslösetaste wird nicht umgesetzt.`nZ.B. erfolgt nach «Enter» kein Zeilenwechsel."
Raw_TT := V_RawSend_TT := "Im Text enthaltene Tastaturbefehle `(z.B. {Enter}`, {Right 3} oder ^c`) werden nicht ausgeführt."
Reset_Recognizer_TT := V_RecoReset_TT := "Diese Option ist nur in seltenen Fällen erforderlich (s. AutoHotkey-Help)."
Case_Sensitive_1_TT := V_CaseSensitive_TT := "Groß- oder Kleinschreibung des Kürzels wird unterschieden."
Case_Sensitive_2_TT := V_CaseConform_TT := "Groß- oder Kleinschreibung des Kürzels wird nicht unterschieden.`nAllerdings erfolgt die Ersetzung in Großbuchstaben`,`nwenn das Kürzel komplett groß geschrieben wurde."
Case_Sensitive_3_TT := V_NoConform_TT := "Wie zuvor; Der Ersetzungstext wird nie verändert."
#Include *i %A_ScriptDir%\Hotstrings.txt
Return

TextAufnehmen:
  ED_3 =
  ClipboardOld = %ClipboardAll%
  Clipboard =
  Send, ^c
  ED_1 = (neu)
  TextAufnahme = Hotstring hinzufügen
  GoSub, TextAufnahme
  ClipWait, 1
  If Clipboard !=
      ED_3 := To_Raw(Clipboard)
  GuiControl, 2:, ED_3, %ED_3%
  Clipboard = %ClipboardOld%
Return

TextAufnahme:
  Gui, 2: Destroy
  IfWinExist, ahk_id %LV_ID%
    {
      Gui, 2: +Owner1
      Gui, +Disabled
    }
  Gui, 2: +LastFound +AlwaysOnTop -MinimizeBox -MaximizeBox
  Gui2_ID := WinExist()
  GroupAdd, Group2_ID, ahk_id %Gui2_ID%
  Gui, 2: Margin, 5, 5
  Gui, 2: Font, s9 norm, MS Sans Serif
  Gui, 2: Add, GroupBox, x5 y5 w320 h107 Section, HotString
  Gui, 2: Font,, Verdana
  Gui, 2: Add, Edit, xs+10 ys+20 w160 Section vED_1 gEdit_1, %ED_1%
  Gui, 2: Font,, MS Sans Serif
  Gui, 2: Add, Button, xs+165 ys-1 w65 Default -TabStop, OK
  Gui, 2: Add, Button, x+5 ys-1 w65 -TabStop, Abbrechen
  Gui, 2: Font,, Verdana
  Gui, 2: Add, Edit, xs+0 ys+30 r3 w300 Section vED_3 gEdit_2, %ED_3%
  Gui, 2: Font,, MS Sans Serif
  Gui, 2: Add, GroupBox, x5 y120 w320 h210 Section, Optionen
  Gui, 2: Add, Checkbox, xs+10 yp+20 vAsterisk Checked%V_Asterisk%, *
  Gui, 2: Add, Text, xs+50 yp, Direkt ersetzen (sonst bei Leerz., Tab, -()[]{}':;"/\, .?!#)
  Gui, 2: Add, Checkbox, xs+10 yp+25 vQuestion Checked%V_QuestMark%, ?
  Gui, 2: Add, Text, xs+50 yp, Ersetzung auch innerhalb von Wörtern
  Gui, 2: Add, Checkbox, xs+10 yp+25 vNo_Backspacing Checked%V_BFollZero%, B0
  Gui, 2: Add, Text, xs+50 yp, Nicht ersetzen, sondern ergänzen (no backspacing)
  Gui, 2: Add, Checkbox, xs+10 yp+25 vOmit Checked%V_OmitEnd%, O
  Gui, 2: Add, Text, xs+50 yp, Zeichen, welches die Ersetzung aufruft ignorieren
  Gui, 2: Add, Checkbox, xs+10 yp+25 vRaw Checked%V_RawSend%, R
  Gui, 2: Add, Text, xs+50 yp, {...} nicht umsetzen, als Klartext ausgeben (raw)
  Gui, 2: Add, Checkbox, xs+10 yp+25 vReset_Recognizer Checked%V_RecoReset%, Z
  Gui, 2: Add, Text, xs+50 yp, Erkennungsmechanismus zurücksetzen
  Gui, 2: Add, Text, xs+10 yp+25, Klein-/Großschreibung des Küzels
  Gui, 2: Font, underline
  Gui, 2: Add, Text, cBlue gCaseHilfe xs+285 yp, Hilfe
  Gui, 2: Font
  V_CaseSensitive := V_CaseType = "C" ? 1 : 0
  Gui, 2: Add, Radio, xs+10 yp+20 vCase_Sensitive_1 Checked%V_CaseSensitive%, beachten
  V_CaseConform := V_CaseType = "C0" ? 1 : 0
  Gui, 2: Add, Radio, xs+85 yp vCase_Sensitive_2 Checked%V_CaseConform%, ignorieren
  V_NoConform := V_CaseType = "C1" ? 1 : 0
  Gui, 2: Add, Radio, xs+160 yp vCase_Sensitive_3 Checked%V_NoConform%, ignorieren/exakt ersetzen
  Gui, 2: Show,, %TextAufnahme%
  OnMessage(0x200, "WM_MouseMove")
Return

Edit_1:
  Suspend, On
  IfWinNotExist, ahk_id %LV_ID%
      Return
  GuiControlGet, ED_1
  If (!RegExMatch(ED_1, "\S+"))
      Return
  If (InStr(StringLine, "`n" . ED_1))
      ControlSend, , {Home}%ED_1%, ahk_id %LV_ID%
Return

Edit_2:
  Suspend, Off
Return

#IfWinActive, ahk_group Group1_ID
F1::
  GoSub, ButtonHilfe
Return
F2::
  GoSub, ButtonBearbeiten
Return
F3::
  GoSub, ButtonSuchen
Return
^Enter::
^NumpadEnter::
  GoSub, Speichern
Return
Del::
  GuiControlGet, FocusedControl, FocusV
  If FocusedControl <> LV_1
      Return
  MsgBox, 36, %ScriptTitle%, Möchten Sie die den Eintrag löschen?
  IfMsgBox, Yes
      GoSub, ButtonLöschen
Return
#IfWinActive

#IfWinActive, ahk_group Group2_ID
^Enter::
^NumpadEnter::
  Suspend, Permit
  GoSub, 2ButtonOK
Return
#IfWinActive

2ButtonOK:
  Gui, 2: +OwnDialogs
  Gui, 2: Submit, NoHide
  If (ED_1 = "" or ED_1 = "(neu)")
    {
      MsgBox, 262192, Achtung!, Geben Sie ein Kürzel ein!
      ControlFocus, Edit1, ahk_id %Gui2_ID%
      Return
    }
  Else If ED_3 =
    {
      MsgBox, 262192, Achtung!, Geben Sie einen Text ein!
      ControlFocus, Edit2, ahk_id %Gui2_ID%
      Return
    }
  ED_2 =
  IfEqual, Asterisk,         1, SetEnv, ED_2, *
  IfEqual, Question,         1, SetEnv, ED_2, %ED_2%?
  IfEqual, No_Backspacing,   1, SetEnv, ED_2, %ED_2%B0
  IfEqual, Omit,             1, SetEnv, ED_2, %ED_2%O
  IfEqual, Raw,              1, SetEnv, ED_2, %ED_2%R
  IfEqual, Reset_Recognizer, 1, SetEnv, ED_2, %ED_2%Z
  IfEqual, Case_Sensitive_3, 1, SetEnv, ED_2, %ED_2%C1
  IfEqual, Case_Sensitive_2, 1, SetEnv, ED_2, %ED_2%
  IfEqual, Case_Sensitive_1, 1, SetEnv, ED_2, %ED_2%C
  If (InStr(ED_2, "R") And !InStr(ED_2, "R0"))
    {
      ED_3 := To_Raw(ED_3)
    }
  Else
    {
      StringReplace, ED_3, ED_3, %A_Tab%, {Tab}, All
      StringReplace, ED_3, ED_3, `n, {Enter}, All#
    }
  If InStr(TextAufnahme, "bearbeiten")
    {
      GoSub, ReplaceHotstring
      GoSub, 2GuiClose
      Return
    }
  IfWinExist, ahk_id %LV_ID%
    {
      Loop, parse, FileContent, `n, `r
        {
          Suche = %A_LoopField%
          StringSplit, Suche, Suche, :
          If ED_1 in %Suche3%
            {
              MsgBox, 262144, %ScriptTitle%, Das Kürzel ist bereits vorhanden.
              ControlFocus, Edit1, ahk_id %Gui2_ID%
              Return
              Break
            }
        }
    }
  Else
    {
      Loop, Read, %ScriptNoExt%.txt
        {
          Suche = %A_LoopReadLine%
          StringSplit, Suche, Suche, :
          If ED_1 in %Suche3%
            {
              MsgBox, 262144, %ScriptTitle%, Das Kürzel ist bereits vorhanden.
              ControlFocus, Edit1, ahk_id %Gui2_ID%
              Return
              Break
            }
        }
    }
  IfWinExist, ahk_id %LV_ID%
    {
      Gosub, AddHotstring
      Return
    }
  FileAppend, `n:%ED_2%:%ED_1%::%ED_3%, %ScriptNoExt%.txt
  Gui, 2: Destroy
  Suspend, Off
  GoSub, SplashMe
  Sleep, 1000
  Reload
  Sleep, 2000
Return

2GuiEscape:
2GuiClose:
2ButtonAbbrechen:
  ED_1 =
  ED_2 =
  OnMessage(0x200, "")
  DllCall("DestroyCursor", "UInt", hCur)
  Gui, 1: -Disabled
  Gui, 2: Destroy
  Suspend, Off
Return

ListeZeigen:
  IfWinExist, ahk_id %Gui1_ID%
    {
      GoSub, GuiClose
	    Return
    }
  Gui, Destroy
  Gui, +LastFound +OwnDialogs +Resize +MinSize
  Gui1_ID := WinExist()
  GroupAdd, Group1_ID, ahk_id %Gui1_ID%
  Gui, Margin, 10, 10
  Gui, Font, Norm s9, MS Sans Serif
  Gui, Add, Text,, Suche in Textspalte:
  Gui, Add, Edit, x110 yp-4 w175 vED_S gDefaultFind r1
  Gui, Add, Button, x+5 yp-1 w135 vBT_Find, S&uchen
  Gui, Add, Button, x+5 yp w135, &Optionen
  Gui, Add, Button, x+5 yp w135, &Hilfe
  Gui, Font,, Verdana
  Gui, Add, ListView, gMyListView vLV_1 x10 yp+30 w695 r32 Sort ReadOnly Grid -Multi HwndLV_ID, Kürzel|Optionen|Text
  Gui, Font,, MS Sans Serif
  Gui, Add, Button, y+5 w135 vBearbeiten, &Bearbeiten
  Gui, Add, Button, x+5 w135 vHinzufügen, Hin&zufügen
  Gui, Add, Button, x+5 w135 vDuplizieren, &Duplizieren
  Gui, Add, Button, x+5 w135 vLöschen, &Löschen
  Gui, Add, Button, x+5 w135 Default gSpeichern vSpeichern, &Schließen
  Gui, Add, StatusBar
  SB_SetParts(82)
  LV_Delete()
  FileRead, FileContent, %ScriptNoExt%.txt
  StringReplace, FileContent, FileContent, `r`n, `n, All
  Loop, Parse, FileContent, `n, `r
    {
      If RegExMatch(A_LoopField,"^:(.*):(.*)::(.*)", HS_)
        {
          If (HS_3)
            {
              LV_Add("", HS_2, HS_1, HS_3)
              StringLine .= HS_2 . "`n"
            }
        }
    }
  FileContent := "`n" . FileContent
  If (SubStr(FileContent, StrLen(FileContent), 1) <> "`n")
    {
      FileContent .= "`n"
    }
  StringTrimRight, StringLine, StringLine, 1
  LV_ModifyCol(1, "74")
  LV_MODIFYCOL(2, "71")
  LV_MODIFYCOL(3, "530")
  SB_SetText(LV_GetCount() . " Einträge", 1)
  SB_SetText(A_ScriptDir . "\" . ScriptNoExt . ".txt", 2)
  Menu, MyContextMenu, Add, Bearbeiten, ButtonBearbeiten
  Menu, MyContextMenu, Add, Duplizieren, ButtonDuplizieren
  Menu, MyContextMenu, Add, Löschen, ButtonLöschen
  Menu, MyContextMenu, Default, Bearbeiten
  Gui, Show, AutoSize Center, %ScriptTitle%
Return

DefaultFind:
  GuiControlGet, ED_S
  If (!RegExMatch(ED_S, "\S+"))
      Return
  GuiControl, +Default, BT_Find
Return

ButtonSuchen:
  Gui, Submit, NoHide
  If (!RegExMatch(ED_S, "\S+"))
      Return
  If (ED_S <> SearchString)
    {
      MatchFlag := 0
      SearchString := ED_S
    }
  MatchFlag := Find_Next(ED_S, MatchFlag)
  If (MatchFlag)
      LV_Modify(MatchFlag, "Select Focus Vis")
Return

ButtonBearbeiten:
  Gui, +OwnDialogs
      _Row := LV_GetNext()
  If (!_Row)
    {
      SplashImage,, CWeeeeee b1 FS10 W180, Es ist kein Eintrag markiert.
      SetTimer, SplashImageOff, -800
      Return
    }
      Loop, % LV_GetCount("Col")
          LV_GetText(ED_%A_Index%, _Row, A_Index)
      _HS := ":" . ED_2 . ":" . ED_1 . "::" . ED_3
      If (InStr(ED_2, "R") And !InStr(ED_2, "R0"))
        {
          ED_3 := From_Raw(ED_3)
        }
;      Else
;        {
;          StringReplace, ED_3, ED_3, {Tab}, %A_Tab%, All
;          StringReplace, ED_3, ED_3, {Enter}, `n, All
;        }
      Old_ED_2 := ED_2
      Old_ED_1 := ED_1
      Old_ED_3 := ED_3
      TextAufnahme = Hotstring bearbeiten
      GoSub, TextAufnahme
      GoSub, ControlsEinstellen
Return

ButtonHinzufügen:
  Gui, +OwnDialogs
  ED_3 =
  ED_1 = (neu)
  TextAufnahme = Hotstring hinzufügen
  GoSub, TextAufnahme
Return

ButtonDuplizieren:
  Gui, +OwnDialogs
  _Row := LV_GetNext()
  If (!_Row)
    {
      SplashImage,, CWeeeeee b1 FS10 W180, Es ist kein Eintrag markiert.
      SetTimer, SplashImageOff, -800
      Return
    }
  Loop, % LV_GetCount("Col")
      LV_GetText(ED_%A_Index%, _Row, A_Index)
  _HS := ":" . ED_2 . ":" . ED_1 . "::" . ED_3
  If (InStr(ED_2, "R") And !InStr(ED_2, "R0"))
    {
      ED_3 := From_Raw(ED_3)
    }
  Else
    {
      StringReplace, ED_3, ED_3, {Tab}, %A_Tab%, All
      StringReplace, ED_3, ED_3, {Enter}, `n, All
    }
  ED_1 = (neu)
  TextAufnahme = Hotstring hinzufügen
  GoSub, TextAufnahme
  GoSub, ControlsEinstellen
Return

ButtonLöschen:
  Gui, +OwnDialogs
  _Row := LV_GetNext()
  If (!_Row)
    {
      SplashImage,, CWeeeeee b1 FS10 W180, Es ist kein Eintrag markiert.
      SetTimer, SplashImageOff, -800
      Return
    }
  Loop, % LV_GetCount("Col")
      LV_GetText(ED_%A_Index%, _Row, A_Index)
  _HS := ":" . ED_2 . ":" . ED_1 . "::" . ED_3
  LV_Delete(_Row)
  LV_Modify(_Row, "Select Focus Vis")
  StringReplace, FileContent, FileContent, `n%_HS%`n, `n
  ChangeFlag := True
  GuiControl, Text, Speichern, &Speichern
  GuiControl, Focus, Speichern
  SB_SetText(LV_GetCount() . " Einträge", 1)
Return

ReplaceHotstring:
  Gui, 1: -Disabled
  Gui, 2: Destroy
  Gui, 1: Default
  If (ED_1 = Old_ED_1 and ED_2 = Old_ED_2 and ED_3 = Old_ED_3)
      Return
  LV_Modify(_Row, "", ED_1, ED_2, ED_3)
  LV_Modify(_Row, "Select Focus Vis")
  StringReplace, FileContent, FileContent, `n%_HS%`n, `n:%ED_2%:%ED_1%::%ED_3%`n
  ChangeFlag := True
  GuiControl, Text, Speichern, &Speichern
  GuiControl, Focus, Speichern
Return

AddHotstring:
  Gui, 1: -Disabled
  Gui, 2: Destroy
  Gui, 1: Default
  LV_Modify(LV_Add("", ED_1, ED_2, ED_3), "Select Focus Vis")
  _HS := ":" . ED_2 . ":" . ED_1 . "::" . ED_3
  FileContent .= _HS . "`n"
  ChangeFlag := True
  GuiControl, Text, Speichern, &Speichern
  GuiControl, Focus, Speichern
  SB_SetText(LV_GetCount() . " Einträge", 1)
Return

MyListView:
  Gui, +OwnDialogs
  If A_GuiEvent = ColClick
    {
      _Row := LV_GetNext(0, "F")
      If (!_Row)
          Return
      LV_Modify(_Row, "Vis")
    }
  If A_GuiEvent = DoubleClick
    {

      _Row := LV_GetNext()
      If (!_Row)
          Return
      GoSub, ButtonBearbeiten
    }
Return

ControlsEinstellen:
  If (InStr(ED_2, "*"))
      GuiControl, 2:, Asterisk, 1
  Else
      GuiControl, 2:, Asterisk, 0
  If (InStr(ED_2, "?"))
      GuiControl, 2:, Question, 1
  Else
      GuiControl, 2:, Question, 0
  If (InStr(ED_2, "B0"))
      GuiControl, 2:, No_Backspacing, 1
  Else
      GuiControl, 2:, No_Backspacing, 0
  If (InStr(ED_2, "O"))
      GuiControl, 2:, Omit, 1
  Else
      GuiControl, 2:, Omit, 0
  If (InStr(ED_2, "R"))
      GuiControl, 2:, Raw, 1
  Else
      GuiControl, 2:, Raw, 0
  If (InStr(ED_2, "Z"))
      GuiControl, 2:, Reset_Recognizer, 1
  Else
      GuiControl, 2:, Reset_Recognizer, 0
  If (InStr(ED_2, "C1"))
      GuiControl, 2:, Case_Sensitive_3, 1
  Else If (InStr(ED_2, "C"))
      GuiControl, 2:, Case_Sensitive_1, 1
  Else
      GuiControl, 2:, Case_Sensitive_2, 1
Return

Speichern:
  Gui, +OwnDialogs
  If (ChangeFlag)
      GoSub, DateiSchreiben
  Gui, Destroy
  VarSetCapacity(FileContent, 0)
Return

GuiClose:
GuiEscape:
  Gui, +OwnDialogs
  If (ChangeFlag)
    {
      MsgBox, 51, %ScriptTitle%, Möchten Sie die Änderungen speichern?
      IfMsgBox, Yes
          GoSub, DateiSchreiben
      IfMsgBox, Cancel
          Return
    }
  Gui, Destroy
  VarSetCapacity(FileContent, 0)
Return

DateiSchreiben:
  If (FileExist(ScriptNoExt . ".tmp"))
    {
      FileDelete, %ScriptNoExt%.tmp
      If ErrorLevel
        {
          MsgBox, 16, %ScriptTitle%, %ScriptNoExt%.tmp konnte nicht gelöscht werden.
          Return
        }
    }
  FileAppend, % SubStr(FileContent, 2, StrLen(FileContent) -2), %ScriptNoExt%.tmp
  If ErrorLevel
    {
      MsgBox, 16, %ScriptTitle%, %ScriptNoExt%.tmp konnte nicht geschrieben werden.
      Return
    }
  FileMove, %ScriptNoExt%.tmp, %ScriptNoExt%.txt, 1
  If ErrorLevel
    {
      MsgBox, 16, %ScriptTitle%, %ScriptNoExt%.txt kann nicht überschrieben werden.
    }
  Gui, Destroy
  SplashImage,, CWeeeeee b1 FS10 W250, Die Änderungen wurden gespeichert.
  Sleep, 500
  Reload
Return

Optionen:
ButtonOptionen:
  Suspend, On
  Gui, 3: Destroy
  Gui, 3: +LastFound -MinimizeBox -MaximizeBox
  Gui3_ID := WinExist()
  Gui, 3: Margin, 10, 10
  Gui, 3: Font, s9 norm, MS Sans Serif
  Gui, 3: Add, GroupBox, w370 r5 Section, Eingabe-Hotkey
  Gui, 3: Add, Text, xs+10 yp+20, Drücken Sie eine Tastenkombination, um den Eingabe-Hotkey zu ändern.`nEs werden nur Kombinationen mit der Strg-Taste akzeptiert (z.B. Strg + #).`nDie Umschalt- und Windows-Taste können hier nicht verwendet werden.
  Gui, 3: Add, Hotkey, w350 v_HOTKEY Limit251, %_HOTKEY%
  Gui, 3: Add, Text,, Benutzen Sie diesen Eingabe-Hotkey, um neue Hotstrings aufzunehmen.`nWenn Sie zuvor Text markieren, wird dieser automatisch übernommen.
  Gui, 3: Add, GroupBox, xm w370 r1 Section, Andere Hotkeys
  Gui, 3: Add, Text, xs+10 yp+20, Der Eingabe-Hotkey in Kombination mit der Umschalt-Taste öffnet die Liste.
  Gui, 3: Add, GroupBox, xm w370 r1 Section, Voreinstellungen
  Gui, 3: Add, Checkbox, xs+10 yp+20 vV_Asterisk Checked%V_Asterisk%, *
  Gui, 3: Add, Checkbox, xp+38 yp vV_QuestMark Checked%V_QuestMark%, ?
  Gui, 3: Add, Checkbox, xp+38 yp vV_BFollZero Checked%V_BFollZero%, B0
  Gui, 3: Add, Checkbox, xp+43 yp vV_OmitEnd Checked%V_OmitEnd%, O
  Gui, 3: Add, Checkbox, xp+38 yp vV_RawSend Checked%V_RawSend%, R
  Gui, 3: Add, Checkbox, xp+38 yp vV_RecoReset Checked%V_RecoReset%, Z
  V_CaseSensitive := V_CaseType = "C" ? 1 : 0
  Gui, 3: Add, Radio, xp+38 yp vV_CaseSensitive Checked%V_CaseSensitive%, C
  V_CaseConform := V_CaseType = "C0" ? 1 : 0
  Gui, 3: Add, Radio, xp+38 yp vV_CaseConform Checked%V_CaseConform%, C0
  V_NoConform := V_CaseType = "C1" ? 1 : 0
  Gui, 3: Add, Radio, xp+43 yp vV_NoConform Checked%V_NoConform%, C1
  Gui, 3: Add, GroupBox, xm w370 h149 Section, Autostart
  Gui, 3: Add, Checkbox, xs+10 yp+20 vAutostart Checked, %A_Space% Automatischer Start beim Anmelden des Windows-Benutzers.
  Gui, 3: Add, Text, xs+10 yp+20, Das Programm benötigt Administratorrechte, um Tastaturcode an andere`nFenster senden zu dürfen. Um in neueren Windows-Versionen nicht jedes`nMal den UAC-Dialog (Benutzerkontensteuerung) bestätigen zu müssen,`nwird empfohlen, das Skript nicht mit obiger Option, sondern über die Win-`ndows-Aufgabenplanung ,Bei Annmeldung des Benutzers’ zu starten.`nAktivieren Sie dort die Option ,Mit höchsten Berechtigungen ausführen’.
  Gui, 3: Font, underline
  Gui, 3: Add, Text, xs+10 y+5 cBlue gTaskSchd, Klicken Sie hier
  Gui, 3: Font
  Gui, 3: Add, Text, x+0 yp, `, um die Windows-Aufgabenplanung zu öffnen.
  Gui, 3: Add, Button, x195 w90 Default, OK
  Gui, 3: Add, Button, xp+95 yp w90, Abbrechen
  Gui, 3: Show,, %ScriptTitle% - Einstellungen
  IfNotExist, %A_Startup%\Hotstrings.lnk
    GuiControl, 3:, Autostart, 0
  OnMessage(0x200, "WM_MouseMove")
Return

TaskSchd:
  If A_OSVersion not in WIN_NT4,WIN_95,WIN_98,WIN_ME,Win_2000,WIN_XP
    {
    Run, %A_WinDir%\System32\taskschd.msc,, UseErrorLevel
    If ErrorLevel = Error
      MsgBox, 16, %ScriptTitle%, Die Windows-Aufgabenplanung kann nicht geöffnet werden!
    }
  Else
    {
    MsgBox, 64, %ScriptTitle%, Für diese Windows-Version ist der Start über die Aufgabenplanung nicht erforderlich.
    GuiControl, 3:, Autostart, 1
    }
Return

3ButtonOK:
  Gui, 3: +OwnDialogs
  Gui, 3: Submit, NoHide
  IniWrite, %V_Asterisk%,  Hotstrings.ini, Vorgaben, DirektErsetzen
  IniWrite, %V_QuestMark%, Hotstrings.ini, Vorgaben, ErsetzAuchIn
  IniWrite, %V_BFollZero%, Hotstrings.ini, Vorgaben, NoBackspacing
  IniWrite, %V_OmitEnd%,   Hotstrings.ini, Vorgaben, ZeichenIgnor
  IniWrite, %V_RawSend%,   Hotstrings.ini, Vorgaben, KlarSenden
  IniWrite, %V_RecoReset%, Hotstrings.ini, Vorgaben, ErkennMechan
  V_CaseType := V_CaseSensitive = 1 ? "C" : V_NoConform = 1 ? "C1" : "C0"
  IniWrite, %V_CaseType%,  Hotstrings.ini, Vorgaben, GrossKlein
  If (_HOTKEY = ERROR or _HOTKEY = "")
    _HOTKEY = ^#
  If _HOTKEY <>
    {
    IniWrite, %_HOTKEY%, Hotstrings.ini, Hotkeys, EingabeKey
    GoSub, HotkeyAendern
    }
  If %Autostart%
    {
    FileCreateShortcut, %A_ScriptFullPath%, %A_Startup%\Hotstrings.lnk, %A_ScriptDir%,, Textersetzungen
    If ErrorLevel
      MsgBox, 262160, %ScriptTitle%, Die Autostart-Verknüpfung konnte nicht erstellt werden.
    }
  Else
    {
    IfExist, %A_Startup%\Hotstrings.lnk
      {
      MsgBox, 308, %ScriptTitle%, Möchten Sie die Verknüpfung im Autostart-Ordner löschen?`n`nDas Programm wird dann nicht mehr automatisch bei`nder Anmeldung des Windows-Benutzers gestartet.
      IfMsgBox, No
        {
        GuiControl, 3:, Autostart, 1
        Return
        }
      FileDelete, %A_Startup%\Hotstrings.lnk
      If ErrorLevel
        MsgBox, 262160, %ScriptTitle%, Die Autostart-Verknüpfung konnte nicht gelöscht werden.
      }
    }
  GoSub, 3GuiClose
Return

3ButtonAbbrechen:
3GuiEscape:
3GuiClose:
  Suspend, Off
  OnMessage(0x200, "")
  Gui, 3: Destroy
Return

HotkeyAendern:
  If _HOTKEY <>
    {
    Hotkey, %_HOTKEY%, TextAufnehmen
    Hotkey, +%_HOTKEY%, ListeZeigen
    hk_rest := _HOTKEY
    hk_temp := ""
    If (InStr(SubStr(hk_rest, 1, -1), "!"))
      {
      hk_rest := RegExReplace(hk_rest, "!", "", "", 1)
      hk_temp :=  "Alt+" . hk_temp
      }
    If (InStr(SubStr(hk_rest, 1, -1), "^"))
      {
      hk_rest := RegExReplace(hk_rest, "\^", "", "", 1)
      hk_temp := "Strg+" . hk_temp
      }
    hk_temp := hk_temp . hk_rest
    If HotkeyMenuAdd <> &Hotstring hinzufügen`t%hk_temp%
      Menu, Tray, Rename, %HotkeyMenuAdd%, &Hotstring hinzufügen`t%hk_temp%
    HotkeyMenuAdd = &Hotstring hinzufügen`t%hk_temp%
    If HotkeyMenuManage <> &Liste anzeigen`tUmschalt+%hk_temp%
      Menu, Tray, Rename, %HotkeyMenuManage%, &Liste anzeigen`tUmschalt+%hk_temp%
    HotkeyMenuManage = &Liste anzeigen`tUmschalt+%hk_temp%
    }
Return

ButtonHilfe:
  Gui, 4: Destroy
  Gui, 4: -MinimizeBox -MaximizeBox
  Gui, 4: Color, FFFFFF
  Gui, 4: Font, Norm s9, MS Sans Serif
  Gui, 4: Add, GroupBox, w680 h485 x10 y5
  Gui, 4: font, s12 bold, Arial
  Gui, 4: Add, Text, x12 y25 w650 Center, Texteingaben über selbstdefinierte Kürzel (Hotstrings)
  Gui, 4: font, s9 norm, Arial
  Gui, 4: Add, Text, x25 y65, Um eigene Hotstrings zu definieren, markieren Sie in einer beliebigen Windows-Anwendung den gewünschten Text`nund drücken dann den Eingabe-Hotkey. Der markierte Text wird automatisch als Ersetzungstext übernommen.`n`nDen Eingabe-Hotkey können Sie selbst festlegen. Klicken Sie hierzu mit der rechten Maustaste auf das Symbol im`nInfobereich der Taskleiste, um in die «Optionen» zu gelangen.`n`nBei der Eingabe der Kürzel und Ersetzungstexte können Sie folgende Optionen für jedes Kürzel einzeln mitspeichern.`n`n*: Ein Abschlusszeichen (z.B. Leerzeichen, Punkt oder Enter) wird zum Auslösen des Hotstrings nicht benötigt.`n`n?: Der Hotstring wird selbst dann ausgelöst, wenn er sich innerhalb eines anderen Wortes befindet. Das heißt, das`nZeichen unmittelbar vor dem Hotstring ist alphanumerisch (ein Buchstabe oder eine Zahl). Wenn zum Beispiel "bh"`nals Kürzel für "Bindehaut" definiert ist, wird beim Schreiben des Wortes "unabhängig" zu "unaBindehaut..." ersetzt.`n`nB0: Die eingetippte Abkürzung wird nicht gelöscht. Der Ersetzungstext wird angehängt (kein Backspacing).`n`nC: Case Sensitive (Unterscheidung zwischen Groß- und Kleinschreibung): Das Kürzel zum Auslösen der Ersetzung`nmuss exakt der gespeicherten Groß/Kleinschreibung entsprechen.`n`nO: Lässt beim Ersetzen eines Hotstrings das Abschlusszeichen aus. Das ist hilfreich, wenn Sie die Endung des Ersatz-`nwortes noch tippen möchten. Zum Beispiel lautet Ihre Ersetzung "Birne" und sie möchten noch "n" anhängen.`n`nR: Sendet den Ersatztext "raw", was heißt, dass er so erscheint, wie er notiert ist, statt das z.B. {Enter} in einen Enter-`nTastendruck oder ^c zu einem Strg+C Tastendruck übersetzt wird.`n`nZ: Setzt den Erkennungsmechanismus nach jedem Auslösen zurück. Das Programm wartet auf einen komplett neuen`nHotstring und verwirft für die Entscheidung alles vorher Eingetippte.
  Gui, 4: Add, Button, x270 y500 w135 Default, &Schließen
  Gui, 4: Show, w700 h535, %ScriptTitle%
Return

Homepage:
  Run http://www.ophthalmostar.de/
  If ErrorLevel = ERROR
    MsgBox, 48, %ScriptName%, Die Webseite konnte nicht geöffnet werden.
Return

4ButtonSchließen:
4GuiClose:
4GuiEscape:
  Gui, 4: Destroy
Return

CaseHilfe:
  Gui, 5: +Owner2
  Gui, 2: +Disabled
  Gui, 5: -Resize -MaximizeBox -Caption +Border
  Gui, 5: Color, FFFFFF
  Gui, 5: Font, s9 norm, Verdana
  Gui, 5: Add, Text,, Klein-/Großschreibung des Kürzels`n`n• beachten (C, Case sensitive):`n`n   Die Abkürzung wird nur erkannt und duch den Textbaustein er-`n   setzt, wenn sie exakt in ihrer definierten Schreibweise eingege-`n   ben wurde.`n`n`n• ignorieren (Standard, Case conform):`n`n   Die Abkürzung wird unabhängig von ihrer Schreibweise erkannt.`n   Wird die Abkürzung allerdings komplett in Großbuchstaben ge-`n   schrieben, wird ebenfalls der Textbaustein komplett in Groß-`n   buchstaben ausgegeben.`n`n`n• ignorieren/exakt ersetzen (C1, no conform):`n`n   Die Abkürzung wird unabhängig von ihrer Schreibweise erkannt.`n   Der Textbaustein wird immer so ausgegeben`, wie er hier einge-`n   tragen wurde.
  Gui, 5: Show
  OnMessage(0x201, "WM_LBUTTONDOWN5")
Return

5GuiClose:
5GuiEscape:
  Gui, 2: -Disabled
  Gui, 5: Destroy
  OnMessage(0x201, "")
Return

SplashMe:
  hs_TipText := strlen(ED_3) > 46 ? SubStr(ED_3,1,44)"..." : ED_3
  TrayTip, Hotstring hinzugefügt:, Kürzel:`t%ED_1%`nText:`t%hs_TipText%,, 17
  Sleep, 1500
Return

REMOVETRAYTIP:
  SetTimer, REMOVETRAYTIP, Off
  TrayTip
Return

GuiSize:
  If (A_EventInfo = 1)
      Return
  GuiControl, Move, LV_1, % "w" . (A_GuiWidth - 20) . " h" . (A_GuiHeight - 93)
  GuiControl, MoveDraw, Bearbeiten, % "y" (A_GuiHeight - 53)
  GuiControl, MoveDraw, Hinzufügen, % "y" (A_GuiHeight - 53)
  GuiControl, MoveDraw, Duplizieren, % "y" (A_GuiHeight - 53)
  GuiControl, MoveDraw, Löschen, % "y" (A_GuiHeight - 53)
  GuiControl, MoveDraw, Speichern, % "y" (A_GuiHeight - 53)
Return

GuiContextMenu:
  If A_GuiControl <> LV_1
      Return
  Menu, MyContextMenu, Show, %A_GuiX%, %A_GuiY%
Return

SplashImageOff:
  SplashImage, Off
Return

ScriptEnde:
  ExitApp
  Sleep, 2000
Return

Find_Next(String, LastRow)
  {
    Global
    Local Options := ""
    Local Text := ""
    Local End := LV_GetCount()
    Local Row := LastRow + 1
    If (Row > End)
      {
        MsgBox, 48, %ScriptTitle%, Das Listenende wurde erreicht.`nDer Suchvorgang wird beendet.
        Send, {Shift}+{Home}
        Return 0
      }
    Loop
      {
        LV_GetText(Options, Row, 2)
        LV_GetText(Text, Row, 3)
        If (InStr(Options, "R") And !InStr(Options, "R0"))
          {
            Text := From_Raw(Text)
          }
        Else
          {
            StringReplace, Text, Text, {Tab}, %A_Tab%, All
            StringReplace, Text, Text, {Enter}, `n, All
          }
        If (InStr(Text, String))
            Return Row
        Row++
        If (Row > End)
          {
            MsgBox, 48, %ScriptTitle%, Das Listenende wurde erreicht.`nDer Suchvorgang wird beendet.
            Send, {Shift}+{Home}
            Return 0
          }
      }
  }

To_Raw(String)
  {
    StringReplace, String, String, ``, ````, All
    StringReplace, String, String, `r`n, ``r, All
    StringReplace, String, String, `n, ``r, All
    StringReplace, String, String, %A_Tab%, ``t, All
    StringReplace, String, String, `;, ```;, All
    Return String
  }

From_Raw(String)
  {
    StringReplace, String, String, ``r, `r`n, All
    StringReplace, String, String, ``t, %A_Tab%, All
    StringReplace, String, String, ```;, `;, All
    StringReplace, String, String, ````, ``, All
    Return String
  }

WM_LBUTTONDOWN5(wParam, lParam)
  {
    GoSub, 5GUICLOSE
  }

WM_MOUSEMOVE()
{
    static CurrControl, PrevControl, _TT ; _TT is kept blank for use by the ToolTip command below.
    If A_Gui not in 2,3
      Return
    CurrControl := A_GuiControl
    If (CurrControl = "Hilfe" || CurrControl = "Klicken Sie hier")
        DllCall("SetCursor", "UInt", (DllCall("LoadCursor", "UInt", NULL, "Int", 32649, "UInt"))) ;IDC_HAND
    Else If (CurrControl <> PrevControl and not InStr(CurrControl, " "))
    {
        ToolTip
        SetTimer, DisplayToolTip, 200
        PrevControl := CurrControl
    }
    Return

    DisplayToolTip:
    SetTimer, DisplayToolTip, Off
    ToolTip, % %CurrControl%_TT ; The leading percent sign tell it to use an expression.
    SetTimer, RemoveToolTip, 3000
    Return

    RemoveToolTip:
    SetTimer, RemoveToolTip, Off
    ToolTip
    Return
}
